#!/bin/zsh
# Copyright 2011 - 2014 Paul Haensch
# This file is part of Busy
#
# Busy is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Busy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with Busy.  If not, see <http://www.gnu.org/licenses/>.


info="$(printf %s\\n "${_GET[i]}" |grep -Ex 'intro|news|[0-9]{10}_[0-9]{3}')"

case "$info" in
  news)
    $ACL_ADDNEWS \
    && file="$(date +%s)_$(apg -M N -a 1 -n 1 -m 3 -x 3).news" \
    || info=''
    ;;
  intro)
    $ACL_EDITINTRO \
    && file="intro" \
    || info=''
    ;;
  *) $ACL_EDITNEWS \
     && file="${info}.news" \
     || info=''
esac

[ -n "$info" ] || echo -n "Location: ?p=Error&i=noaccess\n\n"
[ -n "$info" ] || exit 0

cgi_post

[ -z "${_POST[cancel]}" ] && echo -E "${_POST[text]}" >"$_DATA/Home/${file}"

echo -n "Location: ${HTTP_REFERER}#news_${info}\n\n"
