#!/bin/zsh
# Copyright 2011 Paul Haensch
# This file is part of Busy
#
# Busy is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Busy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with Busy.  If not, see <http://www.gnu.org/licenses/>.

$ACL_CREATETASK || echo "Location: ?p=Error&i=noaccess\n\n"
$ACL_CREATETASK || exit 0

info="${_GET[i]}"

[ -z "$info" ] && info="$(date +%s)_$(apg -M N -a 1 -n 1 -m 3 -x 3)"
descfile="$_DATA/Tasks/$info.meta"
commfile="$_DATA/Tasks/$info.comment.$(date +%s)_$(apg -M N -a 1 -n 1 -m 3 -x 3)"

[ -f "$_DATA/Tasks/$info.lock" ] && rm "$_DATA/Wiki/$info.lock"
anchor=$(ls $_DATA/Tasks |grep -A2 $info |grep '.meta$' |tail -n1 |cut -d. -f1)

cgi_post
headline="${_POST[headline]}"
taskstatus="${_POST[status]}"
section="${_POST[section]}"
description="${_POST[description]}"
comment="${_POST[comm]}"
[ -n "${_POST[cancel]}" ] && cancel=true
[ "${_POST[submit]}" = "Robots click here" ] && cancel=true

if [ -z "$cancel" -a -n "$comment" ]; then
  touch "$_DATA/Tasks/$info"
  echo -e "author=${USER}" > "$commfile"
  echo -e "${comment}" >> "$commfile"
  echo -n "Location: ?p=Tasks&i=$info\n\n"
elif [ -z "$cancel" -a -n "$description" ]; then
  touch "$_DATA/Tasks/$info"
  echo -e "headline=${headline}" > "$descfile"
  echo -e "status=${taskstatus}" >> "$descfile"
  echo -e "section=${section}" >> "$descfile"
  echo -e "${description}" >> "$_DATA/Tasks/$info"
  echo -n "Location: ?p=Tasks#$anchor\n\n"
elif [ -n "$cancel" ]; then
  echo -n "Location: ?p=Tasks#$anchor\n\n"
fi
